<?xml version="1.0" encoding="ISO-8859-1"?><xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:SMLNL="http://www.shef.ac.uk/SpineMLNetworkLayer" xmlns:SMLLOWNL="http://www.shef.ac.uk/SpineMLLowLevelNetworkLayer" xmlns:SMLCL="http://www.shef.ac.uk/SpineMLComponentLayer"xmlns:fn="http://www.w3.org/2005/xpath-functions">
<xsl:output method="text" version="1.0" encoding="UTF-8" indent="yes"/>

<xsl:template match="SMLCL:Regime" mode="doIter">
<xsl:param name="suffix"/>
	 //Regime
         case <xsl:value-of select="concat(translate(@name,' -', '__'), translate(//SMLCL:ComponentClass/@name,' -', '__'))"/>:
		<xsl:apply-templates select="SMLCL:TimeDerivative" mode="doIter">
			<xsl:with-param name="suffix" select="$suffix"/>
		</xsl:apply-templates>
		<xsl:apply-templates select="SMLCL:TimeDerivative" mode="doVarAssign">
			<xsl:with-param name="suffix" select="$suffix"/>
		</xsl:apply-templates>
		break;
</xsl:template>

<xsl:template match="SMLCL:Regime" mode="doTrans">
<xsl:param name="suffix"/>
 	 //Regime Transforms
         case <xsl:value-of select="concat(translate(@name,' -', '__'), translate(//SMLCL:ComponentClass/@name,' -', '__'))"/>:
  		transition = 1;
  		while (transition == 1) {
   		  transition = 0;
   		  <xsl:apply-templates select="SMLCL:OnCondition" mode="doTrans">
	   		  <xsl:with-param name="suffix" select="$suffix"/>
   		  </xsl:apply-templates>
  		}
 	 break;
</xsl:template>

<xsl:template match="SMLCL:Regime" mode="defineRegimes">
#define <xsl:value-of select="concat(translate(@name,' -', '__'), translate(//SMLCL:ComponentClass/@name,' -', '__'))"/><xsl:text> </xsl:text><xsl:number count="SMLCL:Regime" from="//SMLCL:Dynamics" format="1"/> </xsl:template>


<xsl:include href="SpineML_TimeDerivative.xsl"/>
<xsl:include href="SpineML_OnEvent.xsl"/>
<xsl:include href="SpineML_OnCondition.xsl"/>
<xsl:include href="SpineML_Alias.xsl"/>

</xsl:stylesheet>
