<?xml version="1.0" encoding="ISO-8859-1"?><xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:SMLNL="http://www.shef.ac.uk/SpineMLNetworkLayer" xmlns:SMLLOWNL="http://www.shef.ac.uk/SpineMLLowLevelNetworkLayer" xmlns:SMLCL="http://www.shef.ac.uk/SpineMLComponentLayer"xmlns:fn="http://www.w3.org/2005/xpath-functions">
<xsl:output method="text" version="1.0" encoding="UTF-8" indent="yes"/>

<xsl:template name="getSourceSize">
	<xsl:param name="source"/>
	<xsl:for-each select="$source">
		<xsl:if test="local-name(.)='Neuron'">
				<xsl:value-of select="@size"/>
		</xsl:if>
		<xsl:if test="local-name(.)='WeightUpdate'">
			<!-- THIS IS REALLY COMPLICATED -->
			<xsl:if test="count(../SMLNL:OneToOneConnection)=1">
		        <xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
		        <xsl:value-of select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
			</xsl:if>
			<xsl:if test="count(../SMLNL:AllToAllConnection)=1">
		        <xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
		        <xsl:variable name="dstPopSize" select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
		        <xsl:variable name="srcPopSize" select="../../../../../../SMLLOWNL:Neuron/@size"/>
				<xsl:value-of select="number($srcPopSize) * number($dstPopSize)"/>
			</xsl:if>
			<xsl:if test="count(../SMLNL:ConnectionList)>0">
		        <xsl:value-of select="count(../SMLNL:ConnectionList/SMLNL:Connection)"/>
			</xsl:if>	
		</xsl:if>
		<xsl:if test="local-name(.)='PostSynapse'">
				<xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
				<xsl:value-of select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template name="RepeatString">
  <xsl:param name="string" select="''" />
  <xsl:param name="times"  select="1" />
  <xsl:param name="divider"  select="','" />
  <xsl:if test="number($times) &gt; 0">
    <xsl:value-of select="$string" />
    <xsl:if test="number($times) &gt; 1">
		<xsl:value-of select="$divider" />
	</xsl:if>
    <xsl:call-template name="RepeatString">
      <xsl:with-param name="string" select="$string" />
      <xsl:with-param name="times"  select="$times - 1" />
      <xsl:with-param name="divider"  select="$divider" />
    </xsl:call-template>
  </xsl:if>
</xsl:template>

<xsl:template name="OneToOneConnection">
  <xsl:param name="times"  select="1" />
  <xsl:param name="times2"  select="1" />
  <xsl:param name="maxTimes"  select="10" />
  <xsl:param name="divider"  select="','" />
  <xsl:if test="number($times) &lt; number($maxTimes)+1">
    <xsl:if test="$times=$times2">1</xsl:if>
    <xsl:if test="not($times=$times2)">0</xsl:if>
    <xsl:if test="number($times) &lt; number($maxTimes)">
		<xsl:value-of select="$divider" />
	</xsl:if>
    <xsl:call-template name="OneToOneConnection">
      <xsl:with-param name="times"  select="$times + 1" />
      <xsl:with-param name="times2" select="$times2"/>
      <xsl:with-param name="divider"  select="$divider" />
      <xsl:with-param name="maxTimes"  select="$maxTimes" />
    </xsl:call-template>
  </xsl:if>
  <xsl:if test="not(number($times) &lt; number($maxTimes)+1)">
  	<xsl:if test="number($times2) &lt; number($maxTimes)+1">
  	    <xsl:if test="number($times2) &lt; number($maxTimes)">
			<!---->}<xsl:value-of select="$divider" />{<!---->
			<xsl:call-template name="OneToOneConnection">
			  <xsl:with-param name="times"  select="1" />
			  <xsl:with-param name="times2" select="$times2 + 1"/>
			  <xsl:with-param name="divider"  select="$divider" />
			  <xsl:with-param name="maxTimes"  select="$maxTimes" />
			</xsl:call-template>
		</xsl:if>
  	</xsl:if>
  </xsl:if>
</xsl:template>

<xsl:template name="RepeatStringIndividualVals">
  <xsl:param name="input" select="''" />
  <xsl:param name="srcInd"  select="number(1)" />
  <xsl:param name="dstInd"  select="1" />
  <xsl:param name="srcTimes"  select="10" />
  <xsl:param name="dstTimes"  select="10" />
  <xsl:param name="divider"  select="','" />
  <xsl:if test="number($srcInd)&lt;number($srcTimes)+1">
  <xsl:if test="number($dstInd)=number('1')">{</xsl:if>
  <xsl:choose>
  
	  <xsl:when test="number($dstInd)=number($dstTimes) and number($srcInd)&lt;number($srcTimes)+1">
	    <xsl:choose>
                  <xsl:when test="count($input//SMLNL:Connection[number(@src_neuron)=number($srcInd)-1 and number(@dst_neuron)=number($dstInd)-1])&gt;0">
		  	<!---->1<!---->
		  </xsl:when>
		  <xsl:otherwise>
		  	<!---->0<!---->
		  </xsl:otherwise>
	    </xsl:choose>
	    <!---->}<!---->
	    <xsl:if test="number($srcInd)&lt;number($srcTimes)">
	  	  <xsl:value-of select="$divider" />
	    </xsl:if>
		<xsl:call-template name="RepeatStringIndividualVals">
		  <xsl:with-param name="input" select="$input" />
		  <xsl:with-param name="srcInd"  select="$srcInd + 1" />
		  <xsl:with-param name="dstInd"  select="'1'" />
		  <xsl:with-param name="srcTimes"  select="$srcTimes" />
		  <xsl:with-param name="dstTimes"  select="$dstTimes" />
		  <xsl:with-param name="divider"  select="$divider" />
		</xsl:call-template>
	  </xsl:when>

	  <xsl:otherwise>
	  	<xsl:choose>
                        <xsl:when test="count($input//SMLNL:Connection[number(@src_neuron)=number($srcInd)-1 and number(@dst_neuron)=number($dstInd)-1])&gt;0">
		  		<!---->1<!---->
		  	</xsl:when>
		  	<xsl:otherwise>
		  		<!---->0<!---->
		  	</xsl:otherwise>
	  	</xsl:choose>
	  	<xsl:if test="number($dstInd) &lt; number($dstTimes)">
			<xsl:value-of select="$divider" />
		</xsl:if>
		<xsl:call-template name="RepeatStringIndividualVals">
		  <xsl:with-param name="input" select="$input" />
		  <xsl:with-param name="srcInd"  select="$srcInd" />
		  <xsl:with-param name="dstInd"  select="$dstInd + 1" />
		  <xsl:with-param name="srcTimes"  select="$srcTimes" />
		  <xsl:with-param name="dstTimes"  select="$dstTimes" />
		  <xsl:with-param name="divider"  select="$divider" />
		</xsl:call-template>
	  </xsl:otherwise>
	  
  </xsl:choose>
  </xsl:if>
</xsl:template>

<xsl:template name="RepeatStringIndividualValsDelay">
  <xsl:param name="input" select="''" />
  <xsl:param name="srcInd"  select="number(1)" />
  <xsl:param name="dstInd"  select="1" />
  <xsl:param name="srcTimes"  select="10" />
  <xsl:param name="dstTimes"  select="10" />
  <xsl:param name="divider"  select="','" />
  <xsl:if test="number($srcInd)&lt;number($srcTimes)+1">
  <xsl:if test="number($dstInd)=number('1')">{</xsl:if>
  <xsl:choose>
  
	  <xsl:when test="number($dstInd)=number($dstTimes) and number($srcInd)&lt;number($srcTimes)+1">
	    <xsl:choose>
                  <xsl:when test="count($input//SMLNL:Connection[number(@src_neuron)=number($srcInd)-1 and number(@dst_neuron)=number($dstInd)-1])&gt;0">
                        <xsl:value-of select="$input//SMLNL:Connection[number(@src_neuron)=number($srcInd)-1 and number(@dst_neuron)=number($dstInd)-1]/SMLNL:Delay"/>
		  </xsl:when>
		  <xsl:otherwise>
		  	<!---->-1<!---->
		  </xsl:otherwise>
	    </xsl:choose>
	    <!---->}<!---->
	    <xsl:if test="number($srcInd)&lt;number($srcTimes)">
	  	  <xsl:value-of select="$divider" />
	    </xsl:if>
		<xsl:call-template name="RepeatStringIndividualValsDelay">
		  <xsl:with-param name="input" select="$input" />
		  <xsl:with-param name="srcInd"  select="$srcInd + 1" />
		  <xsl:with-param name="dstInd"  select="'1'" />
		  <xsl:with-param name="srcTimes"  select="$srcTimes" />
		  <xsl:with-param name="dstTimes"  select="$dstTimes" />
		  <xsl:with-param name="divider"  select="$divider" />
		</xsl:call-template>
	  </xsl:when>

	  <xsl:otherwise>
	  	<xsl:choose>
                        <xsl:when test="count($input//SMLNL:Connection[number(@src_neuron)=number($srcInd)-1 and number(@dst_neuron)=number($dstInd)-1])&gt;0">
                                <xsl:value-of select="$input//SMLNL:Connection[number(@src_neuron)=number($srcInd)-1 and number(@dst_neuron)=number($dstInd)-1]/SMLNL:Delay"/>
		  	</xsl:when>
		  	<xsl:otherwise>
		  		<!---->-1<!---->
		  	</xsl:otherwise>
	  	</xsl:choose>
	  	<xsl:if test="number($dstInd) &lt; number($dstTimes)">
			<xsl:value-of select="$divider" />
		</xsl:if>
		<xsl:call-template name="RepeatStringIndividualValsDelay">
		  <xsl:with-param name="input" select="$input" />
		  <xsl:with-param name="srcInd"  select="$srcInd" />
		  <xsl:with-param name="dstInd"  select="$dstInd + 1" />
		  <xsl:with-param name="srcTimes"  select="$srcTimes" />
		  <xsl:with-param name="dstTimes"  select="$dstTimes" />
		  <xsl:with-param name="divider"  select="$divider" />
		</xsl:call-template>
	  </xsl:otherwise>
	  
  </xsl:choose>
  </xsl:if>
</xsl:template>


<xsl:template name="PropertyExplicitVals121">
  <xsl:param name="input" select="''" /> <!-- SMLNL:Property -->
  <xsl:param name="index"  select="number(0)" />
  <xsl:param name="length"  select="10" />
  <xsl:param name="divider"  select="','" />
  <!-- IF WE HAVE NOT REACHED THE ROW END -->
  <xsl:if test="number($index)&lt;number($length)">
  	<!-- PRINT OUT VALUE WITH CURRENT INDEX -->
  	<xsl:value-of select="SMLNL:ValueList/SMLNL:Value[@index = $index]/@value"/>
  	<!-- IF INDEX NOT FOUND (THIS MAY NOT BE AN ERROR - COULD BE LAST SPLIT) -->
  	<xsl:if test="count(SMLNL:ValueList/SMLNL:Value[@index = $index]/@value)=0">
  		<!---->-1<!---->
  	</xsl:if>
  	<!-- IF WE ARE NOT AT THE END OF THE ROW -->
  	<xsl:if test="not(number($index)=number($length)-1)">
		<xsl:value-of select="$divider"/>
	</xsl:if>
	<!-- CALL TEMPLATE WITH NEXT INDEX -->
	<xsl:call-template name="PropertyExplicitVals121">
		<xsl:with-param name="input" select="$input" />
		<xsl:with-param name="index"  select="$index + 1" />
		<xsl:with-param name="length"  select="$length" />
		<xsl:with-param name="divider"  select="$divider" />
	</xsl:call-template>
  </xsl:if>
</xsl:template>

<xsl:template name="PropertyExplicitValsA2A">
	<xsl:param name="input" select="''" /> <!-- SMLNL:Property -->
	<xsl:param name="index"  select="number(0)" />
	<xsl:param name="row"  select="number(0)" />
	<xsl:param name="col"  select="number(0)" />
	<xsl:param name="maxRow"  select="10" />
	<xsl:param name="maxCol"  select="10" />
	<xsl:param name="divider"  select="','" />

	<!-- INSERT INITIAL BRACKET -->
	<xsl:if test="$index=0">
		<!---->{<!---->
	</xsl:if>

	<xsl:choose>
	
		<!-- IF WE HAVE NOT REACHED THE ROW END -->
	  <xsl:when test="number($col)&lt;number($maxCol) and number($row)&lt;number($maxRow)">
	  	<!-- PRINT OUT VALUE WITH CURRENT INDEX -->
	  	<xsl:value-of select="SMLNL:ValueList/SMLNL:Value[@index = $index]/@value"/>
	  	<!-- IF INDEX NOT FOUND (THIS MAY NOT BE AN ERROR - COULD BE LAST SPLIT) -->
	  	<xsl:if test="count(SMLNL:ValueList/SMLNL:Value[@index = $index]/@value)=0">
	  		<!---->-1<!---->
	  	</xsl:if>
	  	<!-- IF WE ARE NOT AT THE END OF THE ROW -->
	  	<xsl:if test="not(number($col)=number($maxCol)-1)">
			<xsl:value-of select="$divider"/>
		</xsl:if>
		<!-- CALL TEMPLATE WITH NEXT INDEX -->
		<xsl:call-template name="PropertyExplicitValsA2A">
			<xsl:with-param name="input" select="$input" />
			<xsl:with-param name="row"  select="$row" />
			<xsl:with-param name="col"  select="$col+1" />
			<xsl:with-param name="index"  select="$index+1" />
			<xsl:with-param name="maxRow"  select="$maxRow" />
			<xsl:with-param name="maxCol"  select="$maxCol" />
			<xsl:with-param name="divider"  select="$divider" />
		</xsl:call-template>
	  </xsl:when>
  
	  <!-- IF WE HAVE REACHED THE ROW END BUT NOT COL END -->
	  <xsl:when test="number($col)=number($maxCol) and number($row)&lt;number($maxRow)">
  		<!---->}<!---->
		<xsl:if test="not(number($row)=number($maxRow)-1)">
 	 		<!---->,
<!---->	 		<!---->{<!---->
		</xsl:if>
		<!-- CALL TEMPLATE WITH NEXT INDEX -->
		<xsl:call-template name="PropertyExplicitValsA2A">
			<xsl:with-param name="input" select="$input" />
			<xsl:with-param name="row"  select="$row+1" />
			<xsl:with-param name="index"  select="$index" />
			<xsl:with-param name="maxRow"  select="$maxRow" />
			<xsl:with-param name="maxCol"  select="$maxCol" />
			<xsl:with-param name="divider"  select="$divider" />
		</xsl:call-template>
	  </xsl:when>
	  
	</xsl:choose>
</xsl:template>

<xsl:template name="ConnectionExplicitVals">
	<xsl:param name="input" select="''" /> <!-- SMLNL:Property -->
	<xsl:param name="index"  select="number(0)" />
	<xsl:param name="row"  select="number(0)" />
	<xsl:param name="col"  select="number(0)" />
	<xsl:param name="maxRow"  select="10" />
	<xsl:param name="maxCol"  select="10" />
	<xsl:param name="divider"  select="','" />

	<xsl:for-each select="$input">

		<!-- INSERT INITIAL BRACKET -->
		<xsl:if test="$index=0">
			<!---->{<!---->
		</xsl:if>

		<xsl:choose>
	
			<!-- IF WE HAVE NOT REACHED THE ROW END -->
		  <xsl:when test="number($col)&lt;number($maxCol) and number($row)&lt;number($maxRow)">
		  	<!-- CONNECTION EXISTS -->
		  	<xsl:for-each select="SMLNL:Connection[@dst_neuron = $col and @src_neuron = $row]">
		  		<!---->1<!---->
		  	</xsl:for-each>
		  	<!-- IF INDEX NOT FOUND (THIS MAY NOT BE AN ERROR - COULD BE LAST SPLIT) -->
		  	<xsl:if test="count(SMLNL:Connection[@dst_neuron = $col and @src_neuron = $row])=0">
		  		<!---->0<!---->
		  	</xsl:if>
		  	<!-- IF WE ARE NOT AT THE END OF THE ROW -->
		  	<xsl:if test="not(number($col)=number($maxCol)-1)">
				<xsl:value-of select="$divider"/>
			</xsl:if>
			<!-- CALL TEMPLATE WITH NEXT INDEX -->
			<xsl:call-template name="ConnectionExplicitVals">
				<xsl:with-param name="input" select="$input" />
				<xsl:with-param name="row"  select="$row" />
				<xsl:with-param name="col"  select="$col+1" />
				<xsl:with-param name="index"  select="$index+1" />
				<xsl:with-param name="maxRow"  select="$maxRow" />
				<xsl:with-param name="maxCol"  select="$maxCol" />
				<xsl:with-param name="divider"  select="$divider" />
			</xsl:call-template>
		  </xsl:when>
	  
		  <!-- IF WE HAVE REACHED THE ROW END BUT NOT COL END -->
		  <xsl:when test="number($col)=number($maxCol) and number($row)&lt;number($maxRow)">
	  		<!---->}<!---->
			<xsl:if test="not(number($row)=number($maxRow)-1)">
	 	 		<!---->,
<!---->	 		<!---->{<!---->
			</xsl:if>
			<!-- CALL TEMPLATE WITH NEXT INDEX -->
			<xsl:call-template name="ConnectionExplicitVals">
				<xsl:with-param name="input" select="$input" />
				<xsl:with-param name="row"  select="$row+1" />
				<xsl:with-param name="index"  select="$index" />
				<xsl:with-param name="maxRow"  select="$maxRow" />
				<xsl:with-param name="maxCol"  select="$maxCol" />
				<xsl:with-param name="divider"  select="$divider" />
			</xsl:call-template>
		  </xsl:when>
		  
		</xsl:choose>
	</xsl:for-each>
</xsl:template>

<xsl:template name="DelayExplicitVals">
	<xsl:param name="input" select="''" /> <!-- SMLNL:Property -->
	<xsl:param name="index"  select="number(0)" />
	<xsl:param name="row"  select="number(0)" />
	<xsl:param name="col"  select="number(0)" />
	<xsl:param name="maxRow"  select="10" />
	<xsl:param name="maxCol"  select="10" />
	<xsl:param name="divider"  select="','" />

	<xsl:for-each select="$input">

		<!-- INSERT INITIAL BRACKET -->
		<xsl:if test="$index=0">
			<!---->{<!---->
		</xsl:if>

		<xsl:choose>
	
			<!-- IF WE HAVE NOT REACHED THE ROW END -->
		  <xsl:when test="number($col)&lt;number($maxCol) and number($row)&lt;number($maxRow)">
		  	<!-- CONNECTION EXISTS -->
		  	<xsl:for-each select="SMLNL:Connection[@dst_neuron = $col and @src_neuron = $row]">
		  		<xsl:value-of select="@delay"/>
		  	</xsl:for-each>
		  	<!-- IF INDEX NOT FOUND (THIS MAY NOT BE AN ERROR - COULD BE LAST SPLIT) -->
		  	<xsl:if test="count(SMLNL:Connection[@dst_neuron = $col and @src_neuron = $row])=0">
		  		<!---->-1<!---->
		  	</xsl:if>
		  	<!-- IF WE ARE NOT AT THE END OF THE ROW -->
		  	<xsl:if test="not(number($col)=number($maxCol)-1)">
				<xsl:value-of select="$divider"/>
			</xsl:if>
			<!-- CALL TEMPLATE WITH NEXT INDEX -->
			<xsl:call-template name="DelayExplicitVals">
				<xsl:with-param name="input" select="$input" />
				<xsl:with-param name="row"  select="$row" />
				<xsl:with-param name="col"  select="$col+1" />
				<xsl:with-param name="index"  select="$index+1" />
				<xsl:with-param name="maxRow"  select="$maxRow" />
				<xsl:with-param name="maxCol"  select="$maxCol" />
				<xsl:with-param name="divider"  select="$divider" />
			</xsl:call-template>
		  </xsl:when>
	  
		  <!-- IF WE HAVE REACHED THE ROW END BUT NOT COL END -->
		  <xsl:when test="number($col)=number($maxCol) and number($row)&lt;number($maxRow)">
	  		<!---->}<!---->
			<xsl:if test="not(number($row)=number($maxRow)-1)">
	 	 		<!---->,
<!---->	 		<!---->{<!---->
			</xsl:if>
			<!-- CALL TEMPLATE WITH NEXT INDEX -->
			<xsl:call-template name="DelayExplicitVals">
				<xsl:with-param name="input" select="$input" />
				<xsl:with-param name="row"  select="$row+1" />
				<xsl:with-param name="index"  select="$index" />
				<xsl:with-param name="maxRow"  select="$maxRow" />
				<xsl:with-param name="maxCol"  select="$maxCol" />
				<xsl:with-param name="divider"  select="$divider" />
			</xsl:call-template>
		  </xsl:when>
		  
		</xsl:choose>
	</xsl:for-each>
</xsl:template>

<xsl:template name="RepeatStringIndividualVals1D">
  <xsl:param name="input" select="''" />
  <xsl:param name="default"  select="'0'" />
  <xsl:param name="ind"  select="number(1)" />
  <xsl:param name="times"  select="10" />
  <xsl:param name="divider"  select="','" />
  <xsl:if test="number($ind)=number('1')">{</xsl:if>
  <xsl:choose>

	  <xsl:when test="number($ind)&gt;number($times)">
	  <!---->}<!---->
	  </xsl:when>
	  <xsl:otherwise>
	  	<xsl:choose>
		  	<xsl:when test="count($input//SMLNL:valueInstance[number(SMLNL:index)=number($ind)-1])=1">
		  		<!----><xsl:value-of select="$input//SMLNL:valueInstance[number(SMLNL:index)=number($ind)-1]/SMLNL:value"/><!---->
		  	</xsl:when>
		  	<xsl:otherwise>
		  		<!----><xsl:value-of select="$default"/><!---->
		  	</xsl:otherwise>
	  	</xsl:choose>
	  	<xsl:if test="number($ind) &lt; number($times)">
			<xsl:value-of select="$divider" />
		</xsl:if>
		<xsl:call-template name="RepeatStringIndividualVals1D">
		  <xsl:with-param name="input" select="$input" />
		  <xsl:with-param name="default"  select="$default" />
		  <xsl:with-param name="ind"  select="$ind+1" />
		  <xsl:with-param name="times"  select="$times" />
		  <xsl:with-param name="divider"  select="$divider" />
		</xsl:call-template>
	  </xsl:otherwise>
	  
  </xsl:choose>
</xsl:template>

<xsl:template name="alias_type">

	<xsl:param name="stateVars"/>
	<xsl:param name="maths"/>
	<xsl:choose>
	<xsl:when test="not($stateVars)">
<!-- RETURN -->
	</xsl:when>
	<xsl:otherwise>
	<xsl:variable name="varName" select = "$stateVars[1]/@name"/>
	<xsl:choose>
	<xsl:when test="contains($maths,$varName)">
		<xsl:variable name="startTemp" select="substring-before($maths,$varName)"/>
		<xsl:variable name="endTemp" select="substring-after($maths,$varName)"/>
			<xsl:choose>
			<xsl:when test="contains('+-*/() =&lt;&gt;',substring($startTemp,string-length($startTemp)-1))">
			<xsl:choose>
			<xsl:when test="contains('+-*/() =&lt;&gt;',substring($endTemp,1,1))">
				<!-- MATCH FOUND, SET VAR AND RETURN -->
true</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="alias_type">
					<xsl:with-param name="stateVars" select="$stateVars[position() > 1]"/>
					<xsl:with-param name="maths" select="$maths"/>
				</xsl:call-template>
			</xsl:otherwise>
			</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="alias_type">
					<xsl:with-param name="stateVars" select="$stateVars[position() > 1]"/>
					<xsl:with-param name="maths" select="$maths"/>
				</xsl:call-template>
			</xsl:otherwise>
			</xsl:choose>
	</xsl:when>
	<xsl:otherwise>
		<xsl:call-template name="alias_type">
			<xsl:with-param name="stateVars" select="$stateVars[position() > 1]"/>
			<xsl:with-param name="maths" select="$maths"/>
		</xsl:call-template>
	</xsl:otherwise>
	</xsl:choose>
	</xsl:otherwise>
	</xsl:choose>

</xsl:template>
	
<xsl:template name="add_suffix_helper">

	<xsl:param name="start"/>
	<xsl:param name="end"/>	
	<xsl:param name="params"/>
	<xsl:param name="param"/>
        <xsl:param name="suffix"/>
	<xsl:choose>
		<xsl:when test="contains($end,$param)">
		<xsl:variable name="startTemp" select="concat($start,substring-before($end,$param))"/>
		<xsl:variable name="endTemp" select="substring-after($end,$param)"/>
			<xsl:choose>
			<xsl:when test="contains('+-*/() =&lt;&gt;',substring($startTemp,string-length($startTemp),1))">
			<xsl:choose>
			<xsl:when test="contains('+-*/() =&lt;&gt;',substring($endTemp,1,1))">
			<xsl:call-template name="add_suffix_helper">
				<xsl:with-param name="params" select="$params"/>
				<xsl:with-param name="param" select="$param"/>
				<xsl:with-param name="start" select="concat($startTemp,$param,$suffix)"/>
				<xsl:with-param name="end" select="$endTemp"/>
				<xsl:with-param name="suffix" select="$suffix"/>
			</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
			<xsl:call-template name="add_suffix_helper">
				<xsl:with-param name="params" select="$params"/>
				<xsl:with-param name="param" select="$param"/>
				<xsl:with-param name="start" select="concat($startTemp,$param)"/>
				<xsl:with-param name="end" select="$endTemp"/>
				<xsl:with-param name="suffix" select="$suffix"/>
			</xsl:call-template>
			</xsl:otherwise>
			</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
			<xsl:call-template name="add_suffix_helper">
				<xsl:with-param name="params" select="$params"/>
				<xsl:with-param name="param" select="$param"/>
				<xsl:with-param name="start" select="concat($startTemp,$param)"/>
				<xsl:with-param name="end" select="$endTemp"/>
				<xsl:with-param name="suffix" select="$suffix"/>
			</xsl:call-template>
			</xsl:otherwise>
			</xsl:choose>			
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="add_suffix">
				<xsl:with-param name="params" select="$params[position() > 1]"/>
				<xsl:with-param name="string" select="concat($start,$end)"/>
				<xsl:with-param name="suffix" select="$suffix"/>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>

</xsl:template>

<xsl:template name="add_suffix">

	<xsl:param name="params"/>
	<xsl:param name="string"/>
	<xsl:param name="suffix"/>
	<xsl:choose>
		<xsl:when test="not($params)">
<xsl:value-of select="$string"/>
		</xsl:when>
		<xsl:otherwise>
		<xsl:variable name="param" select = "$params[1]/@name"/>
			<xsl:choose>
			<xsl:when test="contains($string,$param)">
			<xsl:call-template name="add_suffix_helper">
				<xsl:with-param name="params" select="$params"/>
				<xsl:with-param name="param" select="$param"/>
				<xsl:with-param name="start" select="@thisshouldnotexist"/>
				<xsl:with-param name="end" select="$string"/>
				<xsl:with-param name="suffix" select="$suffix"/>
			</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
			<xsl:call-template name="add_suffix">
				<xsl:with-param name="params" select="$params[position() > 1]"/>
				<xsl:with-param name="string" select="$string"/>
				<xsl:with-param name="suffix" select="$suffix"/>
			</xsl:call-template>
			</xsl:otherwise>
			</xsl:choose>
		</xsl:otherwise>
	</xsl:choose>

</xsl:template>	

<xsl:template name="get_output_number">
<xsl:param name="number"/>
<xsl:param name="prototypeList"/>
<xsl:param name="finalPortName"/>
<!-- count outputs in first prototype -->
<xsl:choose>
	<xsl:when test="count($prototypeList)=1">
		<xsl:for-each select="document($prototypeList[1])//SMLCL:ComponentClass">
			<xsl:variable name="finalPortID" select="//SMLCL:AnalogReceivePort[@name=$finalPortName] | //SMLCL:AnalogReducePort[@name=$finalPortName] | //SMLCL:AnalogSendPort[@name=$finalPortName] | //SMLCL:EventReceivePort[@name=$finalPortName] | //SMLCL:EventSendPort[@name=$finalPortName]"/>
			<xsl:variable name="finalCount" select="count($finalPortID/preceding::SMLCL:AnalogSendPort)+count($finalPortID/preceding::SMLCL:EventSendPort)"/>
			<xsl:value-of select="number($finalCount) + number($number)"/>
		</xsl:for-each>
	</xsl:when>
	<xsl:otherwise>
		<xsl:variable name="extraCount" select="count(document($prototypeList[1])//SMLCL:AnalogSendPort | document($prototypeList[1])//SMLCL:EventSendPort)"/>
		<xsl:call-template name="get_output_number">
			<xsl:with-param name="number" select="number($number) + number($extraCount)"/>
			<xsl:with-param name="prototypeList" select="$prototypeList[position() > 1]"/>
			<xsl:with-param name="finalPortName" select="$finalPortName"/>
		</xsl:call-template>
	</xsl:otherwise>
</xsl:choose>
</xsl:template>




<xsl:template name="port_number">
<!-- Given a src component name, and a port name, this template will print the 
port number of that port within the node. DOES NOT HANDLE componentInstances YET -->
<xsl:param name="src"/>
<xsl:param name="port"/>
<!-- Find src in tree -->
<xsl:variable name="src_node" select="//*[@name=$src]"/>
<xsl:for-each select="$src_node">
<!-- switch type -->
<xsl:if test="local-name($src_node)='Neuron'">
	<xsl:variable name="proj_inputs" select="/SMLLOWNL:SpineML//SMLLOWNL:Projection[@dst_population=$src]//SMLLOWNL:Synapse"/>
	<!-- get all the components that make up the node -->
	<xsl:variable name="all_components" select="$proj_inputs//SMLLOWNL:WeightUpdate/@url | $proj_inputs//SMLLOWNL:PostSynapse/@url | $src_node/@url"/>
	
	<xsl:for-each select="$all_components">
		<!-- find the component that holds the port, and get the number in the sequence -->
		<xsl:variable name="component" select="generate-id(.)"/>	
		<xsl:variable name="curr_node_ind" select="position()"/>	
		<!-- apply the port number generation template -->
		<xsl:if test="generate-id($src_node/../SMLLOWNL:Neuron/@url)=$component">
			<xsl:call-template name="get_output_number">
				<xsl:with-param name="number" select="0"/>
				<xsl:with-param name="prototypeList" select="$all_components[position()&lt;=number($curr_node_ind)]"/>
				<xsl:with-param name="finalPortName" select="$port"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:if>
<xsl:if test="local-name($src_node)='WeightUpdate'">
        <xsl:variable name="ownerPopName" select="../../@dst_population"/>
	<xsl:variable name="ownerPop" select="/SMLLOWNL:SpineML//SMLLOWNL:Population[SMLLOWNL:Neuron/@name=$ownerPopName]"/>
	<xsl:variable name="proj_inputs" select="/SMLLOWNL:SpineML//SMLLOWNL:Projection[@dst_population=$ownerPopName]//SMLLOWNL:Synapse"/>
	<xsl:variable name="all_components" select="$proj_inputs//SMLLOWNL:WeightUpdate/@url | $proj_inputs//SMLLOWNL:PostSynapse/@url | $ownerPop/SMLLOWNL:Neuron/@url"/>	
	<xsl:for-each select="$all_components">
		<xsl:variable name="component" select="generate-id(.)"/>	
		<xsl:variable name="curr_node_ind" select="position()"/>
		<xsl:if test="generate-id($src_node/@url)=$component">
			<xsl:call-template name="get_output_number">
				<xsl:with-param name="number" select="0"/>
				<xsl:with-param name="prototypeList" select="$all_components[position()&lt;=number($curr_node_ind)]"/>
				<xsl:with-param name="finalPortName" select="$port"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:if>
<xsl:if test="local-name($src_node)='PostSynapse'">
        <xsl:variable name="ownerPopName" select="../../@dst_population"/>
	<xsl:variable name="ownerPop" select="/SMLLOWNL:SpineML//SMLLOWNL:Population[SMLLOWNL:Neuron/@name=$ownerPopName]"/>
	<xsl:variable name="proj_inputs" select="/SMLLOWNL:SpineML//SMLLOWNL:Projection[@dst_population=$ownerPopName]//SMLLOWNL:Synapse"/>
	<xsl:variable name="all_components" select="$proj_inputs//SMLLOWNL:WeightUpdate/@url | $proj_inputs//SMLLOWNL:PostSynapse/@url | $ownerPop/SMLLOWNL:Neuron/@url"/>
	<xsl:for-each select="$all_components">
		<xsl:variable name="component" select="generate-id(.)"/>	
		<xsl:variable name="curr_node_ind" select="position()"/>	
		<xsl:if test="generate-id($src_node/@url)=$component">
			<xsl:call-template name="get_output_number">
				<xsl:with-param name="number" select="0"/>
				<xsl:with-param name="prototypeList" select="$all_components[position()&lt;=number($curr_node_ind)]"/>
				<xsl:with-param name="finalPortName" select="$port"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:if>
</xsl:for-each>
</xsl:template>


<xsl:template name="get_input_number">
<xsl:param name="number"/>
<xsl:param name="prototypeList"/>
<xsl:param name="finalPortName"/>
<!-- count outputs in first prototype -->
<xsl:choose>
	<xsl:when test="count($prototypeList)=1">
		<xsl:for-each select="document($prototypeList[1])//SMLCL:ComponentClass">
			<xsl:variable name="finalPortID" select="//SMLCL:AnalogReceivePort[@name=$finalPortName] | //SMLCL:AnalogReducePort[@name=$finalPortName] | //SMLCL:AnalogSendPort[@name=$finalPortName] | //SMLCL:EventReceivePort[@name=$finalPortName] | //SMLCL:EventSendPort[@name=$finalPortName]"/>
			<xsl:variable name="finalCount" select="count($finalPortID/preceding::SMLCL:AnalogReceivePort)+
			count($finalPortID/preceding::SMLCL:AnalogReducePort)+
			count($finalPortID/preceding::SMLCL:EventReceivePort)"/>
			<xsl:value-of select="number($finalCount) + number($number)"/>
		</xsl:for-each>
	</xsl:when>
	<xsl:otherwise>
		<xsl:variable name="extraCount" select="count(document($prototypeList[1])//SMLCL:AnalogReceivePort | document($prototypeList[1])//SMLCL:AnalogReducePort | document($prototypeList[1])//SMLCL:EventReceivePort)"/>
		<xsl:call-template name="get_input_number">
			<xsl:with-param name="number" select="number($number) + number($extraCount)"/>
			<xsl:with-param name="prototypeList" select="$prototypeList[position() > 1]"/>
			<xsl:with-param name="finalPortName" select="$finalPortName"/>
		</xsl:call-template>
	</xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template name="input_port_number">
<!-- Given a src component name, and a port name, this template will print the 
port number of that port within the node. DOES NOT HANDLE componentInstances YET -->
<xsl:param name="src"/>
<xsl:param name="port"/>
<!-- Find src in tree -->
<xsl:variable name="src_node" select="//*[@name=$src]"/>
<xsl:for-each select="$src_node">
<!-- switch type -->
<xsl:if test="local-name($src_node)='Neuron'">
	<xsl:variable name="proj_inputs" select="/SMLLOWNL:SpineML//SMLLOWNL:Projection[@dst_population=$src]//SMLLOWNL:Synapse"/>
	<!-- get all the components that make up the node -->
	<xsl:variable name="all_components" select="$proj_inputs//SMLLOWNL:WeightUpdate/@url | $proj_inputs//SMLLOWNL:PostSynapse/@url | $src_node/@url"/>
	
	<xsl:for-each select="$all_components">
		<!-- find the component that holds the port, and get the number in the sequence -->
		<xsl:variable name="component" select="generate-id(.)"/>	
		<xsl:variable name="curr_node_ind" select="position()"/>	
		<!-- apply the port number generation template -->
		<xsl:if test="generate-id($src_node/../SMLLOWNL:Neuron/@url)=$component">
			<xsl:call-template name="get_input_number">
				<xsl:with-param name="number" select="0"/>
				<xsl:with-param name="prototypeList" select="$all_components[position()&lt;=number($curr_node_ind)]"/>
				<xsl:with-param name="finalPortName" select="$port"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:if>
<xsl:if test="local-name($src_node)='WeightUpdate'">
        <xsl:variable name="ownerPopName" select="../../@dst_population"/>
	<xsl:variable name="ownerPop" select="/SMLLOWNL:SpineML//SMLLOWNL:Population[SMLLOWNL:Neuron/@name=$ownerPopName]"/>
	<xsl:variable name="proj_inputs" select="/SMLLOWNL:SpineML//SMLLOWNL:Projection[@dst_population=$ownerPopName]//SMLLOWNL:Synapse"/>
	<xsl:variable name="all_components" select="$proj_inputs//SMLLOWNL:WeightUpdate/@url | $proj_inputs//SMLLOWNL:PostSynapse/@url | $ownerPop/SMLLOWNL:Neuron/@url"/>	
	<xsl:for-each select="$all_components">
		<xsl:variable name="component" select="generate-id(.)"/>	
		<xsl:variable name="curr_node_ind" select="position()"/>
		<xsl:if test="generate-id($src_node/@url)=$component">
			<xsl:call-template name="get_input_number">
				<xsl:with-param name="number" select="0"/>
				<xsl:with-param name="prototypeList" select="$all_components[position()&lt;=number($curr_node_ind)]"/>
				<xsl:with-param name="finalPortName" select="$port"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:if>
<xsl:if test="local-name($src_node)='PostSynapse'">
        <xsl:variable name="ownerPopName" select="../../@dst_population"/>
	<xsl:variable name="ownerPop" select="/SMLLOWNL:SpineML//SMLLOWNL:Population[SMLLOWNL:Neuron/@name=$ownerPopName]"/>
	<xsl:variable name="proj_inputs" select="/SMLLOWNL:SpineML//SMLLOWNL:Projection[@dst_population=$ownerPopName]//SMLLOWNL:Synapse"/>
	<xsl:variable name="all_components" select="$proj_inputs//SMLLOWNL:WeightUpdate/@url | $proj_inputs//SMLLOWNL:PostSynapse/@url | $ownerPop/SMLLOWNL:Neuron/@url"/>
	<xsl:for-each select="$all_components">
		<xsl:variable name="component" select="generate-id(.)"/>	
		<xsl:variable name="curr_node_ind" select="position()"/>
		<xsl:if test="generate-id($src_node/@url)=$component">
			<xsl:call-template name="get_input_number">
				<xsl:with-param name="number" select="0"/>
				<xsl:with-param name="prototypeList" select="$all_components[position()&lt;=number($curr_node_ind)]"/>
				<xsl:with-param name="finalPortName" select="$port"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:if>
</xsl:for-each>
</xsl:template>

<xsl:template name="number_of_input_ports">
<xsl:param name="all_components"/>
<xsl:param name="value" select="number('0')"/>
<xsl:choose>
	<xsl:when test="count($all_components)=0">0</xsl:when>
	<xsl:otherwise>
	<xsl:choose>
		<xsl:when test="count($all_components)=1">
			<xsl:value-of select="number($value)+count(document($all_components[1])//SMLCL:AnalogReceivePort | document($all_components[1])//SMLCL:AnalogReducePort |  document($all_components[1])//SMLCL:EventReceivePort)"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="number_of_input_ports">
				<xsl:with-param name="all_components" select="$all_components[position()&gt;1]"/>
				<xsl:with-param name="value" select="number($value)+count(document($all_components[1])//SMLCL:AnalogReceivePort | document($all_components[1])//SMLCL:AnalogReducePort |  document($all_components[1])//SMLCL:EventReceivePort)"/>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
	</xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template name="number_of_output_ports">
<xsl:param name="all_components"/>
<xsl:param name="value" select="number('0')"/>
<xsl:choose>
	<xsl:when test="count($all_components)=0">0</xsl:when>
	<xsl:otherwise>
	<xsl:choose>
		<xsl:when test="count($all_components)=1">
			<xsl:value-of select="number($value)+count(document($all_components[1])//SMLCL:AnalogSendPort | document($all_components[1])//SMLCL:EventSendPort)"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="number_of_output_ports">
				<xsl:with-param name="all_components" select="$all_components[position()&gt;1]"/>
				<xsl:with-param name="value" select="number($value)+count(document($all_components[1])//SMLCL:AnalogSendPort | document($all_components[1])//SMLCL:EventSendPort)"/>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
	</xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template name="component_size">
<xsl:param name="srcObjName"/>
<xsl:param name="modelRoot"/>
<xsl:for-each select="$modelRoot//*[@name=$srcObjName]">
<xsl:if test="local-name(.)='Neuron'">
        <xsl:value-of select="@size"/>
</xsl:if>
<xsl:if test="local-name(.)='WeightUpdate'">
	<!-- THIS IS REALLY COMPLICATED -->
        <xsl:if test="count(../SMLNL:OneToOneConnection)=1">
                <xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
                <xsl:value-of select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
	</xsl:if>
        <xsl:if test="count(../SMLNL:AllToAllConnection)=1">
                <xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
                <xsl:variable name="dstPopSize" select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
                <xsl:variable name="srcPopSize" select="../../../../../../SMLLOWNL:Neuron/@size"/>
		<xsl:value-of select="number($srcPopSize) * number($dstPopSize)"/>
	</xsl:if>
        <xsl:if test="count(../SMLNL:ConnectionList)>0">
                <xsl:value-of select="count(../SMLNL:ConnectionList/SMLNL:Connection)"/>
	</xsl:if>	
</xsl:if>
<xsl:if test="local-name(.)='PostSynapse'">
        <xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
        <xsl:value-of select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
</xsl:if>
</xsl:for-each>
</xsl:template> 

<xsl:template name="write_indices_output">
<xsl:param name="indices"/>
<xsl:param name="component"/>
<xsl:param name="outputNumber"/>
<xsl:param name="port"/>
<xsl:for-each select="$component">
<!-- GET COMPONENT SIZE -->
<xsl:variable name="size">
	<xsl:if test="local-name(.)='Neuron'">
		    <xsl:value-of select="@size"/>
	</xsl:if>
	<xsl:if test="local-name(.)='WeightUpdate'">
		<!-- THIS IS REALLY COMPLICATED -->
		    <xsl:if test="count(../SMLNL:OneToOneConnection)=1">
		            <xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
		            <xsl:value-of select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
		</xsl:if>
		    <xsl:if test="count(../SMLNL:AllToAllConnection)=1">
		            <xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
		            <xsl:variable name="dstPopSize" select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
		            <xsl:variable name="srcPopSize" select="../../../../../../SMLLOWNL:Neuron/@size"/>
			<xsl:value-of select="number($srcPopSize) * number($dstPopSize)"/>
		</xsl:if>
		    <xsl:if test="count(../SMLNL:ConnectionList)>0">
		            <xsl:value-of select="count(../SMLNL:ConnectionList/SMLNL:Connection)"/>
		</xsl:if>	
	</xsl:if>
	<xsl:if test="local-name(.)='PostSynapse'">
		    <xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
		    <xsl:value-of select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
	</xsl:if>
</xsl:variable>
<!-- GET COMPONENT SUFFIX -->
<xsl:variable name="suffix">
	<xsl:value-of select="translate(@name,' -','__')"/>
</xsl:variable>
<xsl:choose>
	<xsl:when test="$indices">
	<xsl:variable name="index" select="number(substring-before($indices,','))"/>
	<xsl:if test="contains($indices, ',')">
		<xsl:value-of select="$port"/><xsl:value-of select="$suffix"/>[<xsl:value-of select="$index"/>] <!---->
	</xsl:if>
	<xsl:if test="not(contains($indices, ','))">
		<xsl:value-of select="$port"/><xsl:value-of select="$suffix"/>[<xsl:value-of select="$indices"/>] <!---->
	</xsl:if>
	<xsl:call-template name="write_indices_output">
		<xsl:with-param name="indices" select="substring-after($indices,',')"/>
		<xsl:with-param name="component" select="$component"/>
		<xsl:with-param name="port" select="$port"/>
		<xsl:with-param name="outputNumber" select="$outputNumber"/>
	</xsl:call-template>
	</xsl:when>
</xsl:choose>
</xsl:for-each>
</xsl:template> 


<xsl:template name="write_printf_output">
<xsl:param name="indices"/>
<xsl:choose>
	<xsl:when test="$indices">
	<xsl:variable name="index" select="number(substring-before($indices,','))"/>
	<!---->, %f<!---->
	<xsl:call-template name="write_printf_output">
		<xsl:with-param name="indices" select="substring-after($indices,',')"/>
	</xsl:call-template>
	</xsl:when>
</xsl:choose>
</xsl:template> 

<xsl:template name="write_indices_output_all">
<xsl:param name="indices"/>
<xsl:param name="component"/>
<xsl:param name="outputNumber"/>
<xsl:param name="port"/>
<xsl:param name="number" select="number('0')"/>
<xsl:for-each select="$component">
<!-- GET COMPONENT SIZE -->
<xsl:variable name="size">
	<xsl:if test="local-name(.)='Neuron'">
		    <xsl:value-of select="@size"/>
	</xsl:if>
	<xsl:if test="local-name(.)='WeightUpdate'">
		<!-- THIS IS REALLY COMPLICATED -->
		    <xsl:if test="count(../SMLNL:OneToOneConnection)=1">
		            <xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
		            <xsl:value-of select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
		</xsl:if>
		    <xsl:if test="count(../SMLNL:AllToAllConnection)=1">
		            <xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
		            <xsl:variable name="dstPopSize" select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
		            <xsl:variable name="srcPopSize" select="../../../../../../SMLLOWNL:Neuron/@size"/>
			<xsl:value-of select="number($srcPopSize) * number($dstPopSize)"/>
		</xsl:if>
		    <xsl:if test="count(../SMLNL:ConnectionList)>0">
		            <xsl:value-of select="count(../SMLNL:ConnectionList/SMLNL:Connection)"/>
		</xsl:if>	
	</xsl:if>
	<xsl:if test="local-name(.)='PostSynapse'">
		    <xsl:variable name="ownerPopName" select="../../../../@dst_population"/>
		    <xsl:value-of select="/SMLLOWNL:SpineML//SMLLOWNL:Neuron[SMLNL:Name=$ownerPopName]/@size"/>
	</xsl:if>
</xsl:variable>
<!-- GET COMPONENT SUFFIX -->
<xsl:variable name="suffix">
	<xsl:value-of select="translate(@name,' -','__')"/>
</xsl:variable>
<xsl:choose>
	<xsl:when test="$indices &gt; number($number)">
	 	<xsl:value-of select="$port"/><xsl:value-of select="$suffix"/>[<xsl:value-of select="$number"/>] <!---->
		<xsl:call-template name="write_indices_output_all">
			<xsl:with-param name="indices" select="$indices"/>
			<xsl:with-param name="component" select="$component"/>
			<xsl:with-param name="port" select="$port"/>
			<xsl:with-param name="outputNumber" select="$outputNumber"/>
			<xsl:with-param name="number" select="number($number)+1"/>
		</xsl:call-template>
	</xsl:when>
</xsl:choose>
</xsl:for-each>
</xsl:template> 

<xsl:template name="write_printf_output_all">
<xsl:param name="indices"/>
<xsl:param name="number" select="number('0')"/>
<xsl:choose>
	<xsl:when test="$indices &gt; number($number)">
	<xsl:variable name="index" select="number(substring-before($indices,','))"/>
	<!---->, %f<!---->
	<xsl:call-template name="write_printf_output_all">
		<xsl:with-param name="indices" select="$indices"/>
		<xsl:with-param name="number" select="number($number)+1"/>
	</xsl:call-template>
	</xsl:when>
</xsl:choose>
</xsl:template> 





</xsl:stylesheet>
